#include "Input.h"
ostream & operator << (ostream& out, Input & inp){
	string comm = "";
	out<<comm<<"NITER\t"<<inp._niter<<endl;
	out<<comm<<"BURNIN\t"<<inp._bi<<endl;
	out<<comm<<"TS\t"<<inp._ts<<endl;
	out<<comm<<"TE\t"<<inp._te<<endl;
	out<<comm<<"TC\t"<<inp._tc<<endl;
	out<<comm<<"DURA\t"<<inp._du<<endl;
	out<<comm<<"G\t"<<inp._g_ini<<" "<<inp._g_win<<" "<<inp._g_min<<" "<<inp._g_max<<endl;
	out<<comm<<"E\t"<<inp._e_ini<<" "<<inp._e_win<<" "<<inp._e_min<<" "<<inp._e_max<<endl;
	out<<comm<<"EOPT\t"<<inp._eopt_ini<<" "<<inp._eopt_win<<" "<<inp._eopt_min<<" "<<inp._eopt_max<<endl;
	out<<comm<<"S\t"<<inp._s_ini<<" "<<inp._s_win<<" "<<inp._s_min<<" "<<inp._s_max<<endl;
	out<<comm<<"LNTF\t"<<inp._lntf_ini<<" "<<inp._lntf_win<<" "<<inp._lntf_min<<" "<<inp._lntf_max<<endl;	
	out<<comm<<"JPA\t"<<inp._jpa<<endl;
	if(inp._dmat.size()>0){
		int size = inp._dmat.size();
		out<<comm<<"DMAT\t";
		
		for(int i=0; i< int(size/4); i++){
			for(int j=0; j<4; j++){
				out<<inp._dmat[i*4+j]<<" ";
			}
			out<<comm<<endl;
		}
		out<<"//"<<endl;
	}
}
Input::Input(string fname){
	ifstream ifs(fname.c_str());
	string buf = "";
	string code;	
	while(getline(ifs,buf)){
		istringstream iss(buf);
		iss>>code;	
		if(code == "E"){
			iss>>_e_ini; iss>>_e_win; iss>>_e_min; iss>>_e_max;
		}else if(code == "EOPT"){
			iss>>_eopt_ini; iss>>_eopt_win; iss>>_eopt_min; iss>>_eopt_max;
		}else if(code == "LNTF"){
			iss>>_lntf_ini>>_lntf_win>>_lntf_min>>_lntf_max;
		}else if(code == "NITER"){ iss>>_niter;
		}else if(code == "TS"){ iss>>_ts;
		}else if(code == "TE"){ iss>>_te;
		}else if(code == "TC"){ iss>>_tc;
		}else if(code == "DURA"){ iss>>_du;
		}else if(code == "G"){
			iss>>_g_ini; iss>>_g_win; iss>>_g_min; iss>>_g_max;
		}else if(code == "W"){
			iss>>_w_ini; iss>>_w_win; iss>>_w_min; iss>>_w_max;
		}else if(code == "S"){
			iss>>_s_ini; iss>>_s_win; iss>>_s_min; iss>>_s_max;
		}else if(code == "JPA"){ iss>>_jpa;
		}else if(code == "BURNIN"){
			iss >>_bi;
		}else if(code == "DMAT"){
			while(getline(ifs,buf)){
				istringstream iss(buf);
				if(buf=="//") break;
				int val=0;
				while(!iss.eof()){
					iss>>val;
					_dmat.push_back(val);
				}
			}
		}
	}
	/*
	 if(_eterm.size() > 0){
	 _lambda = -1;
	 _strat = -1;
	 }
	 */
	ifs.close();
	_iter = 0;
}
Input::~Input(){
}
