/*
 *
 *  Created by Hyunmin Kim.
 *
 */

#ifndef _Input_H_
#define _Input_H_
#include "Util.h"
class Input{
public:
	Input(string fname);
	~Input();
	// MCMC controls
	int _niter;
	int _iter;
	vector<int> _dmat;
	int _du;
	double _e_ini, _e_win, _e_min, _e_max; // energy term
	double _eopt_ini, _eopt_win, _eopt_min, _eopt_max; // energy term
	double _lntf_ini, _lntf_win, _lntf_min, _lntf_max; // log [TF] mu
	double _g_ini, _g_win, _g_min, _g_max; // energy term
	double _w_ini, _w_win, _w_min, _w_max; // prebound freq
	double _s_ini, _s_win, _s_min, _s_max; // energy error term
	double _jpa; //jump scale
	int _bi;
	
	double _T;
	double _ts; //starting temperature
	double _te; //target temperature
	double _tc; // cooling down step
	
	void CalcT(){
		double tmp = _ts*pow(_te/_ts, _iter/double(_tc));
		if(tmp < _te) _T = _te;
		else _T = tmp;
	}
	bool next(){ _iter++; CalcT(); return(_iter < _niter);}
private:
	friend ostream & operator << (ostream& out, Input & inp);
};
#endif

