#ifndef _UTIL_H_
#define _UTIL_H_

#include <string>
#include <sstream>
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <iterator>
#include <math.h>
#include <ctime> 
#include <cstdlib>
#include "rng.h"
#include <sys/stat.h>


static RNG _rng;
#define FOR(i,n) for(i=0; i<n; i++)
#define space(i,j) i*4+j
//#define PI 3.141592653589793238462643 

using namespace std;
/*
 using std::endl;
 using std::string;
 using std::ostringstream;
 using std::vector;
 */

void precomputeLogTable(double *LUT); 
void initLookup(int theN);
double logarithm(double val);

int RevComp(int x);
int fexist(const char * filename);
vector<int> RevComp(vector<int> x);
double DNorm(double x, double mu, double sigma);
double DLogNorm(double x, double mu, double sigma);
vector<double> GenLogFactorial(int n);
double LogFactorial(int);
double LogCombi(int, int);
double Rand(double,double);
int RandIdx(int from, int to);
vector<int> DiffIdx(int n, vector<int> & v2);
double Mean(vector<double> &);
string ToString(const int arg);
string ToString(vector<int> arg, string sep="");
void Tokenize(const string& str, vector<string>& tokens, const string& delimiters = " ");
void Matinv (double x[], int n, int m, double space[]);
void QtoPi (double Q[], double pi[], int n, double *space);
void QtoP (double Q[], double t, double P[]);
void Multiply(double A[], double B[], double C[]);
void Scale(double A[], double B, double C[]);
void PrintMat(FILE *fh, double mat[]);
template <class T>
void PrintVec(vector<T> & v, string deli = " ");
void Shuffle(vector<int> & v);
vector<int> SampleIdx(int N, int n=-1);

#endif
